package com.example.educode.controller.fragment;


import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RadioButton;

import com.example.educode.controller.activity.FormationActivity;
import com.example.educode.controller.activity.MainMenuActivity;
import com.example.educode.R;


/**
 * A simple {@link Fragment} subclass.
 */
public class AvatarFragment extends Fragment {

    private Button avatarButton;
    private RadioButton radioButtonBoy1;
    private RadioButton radioButtonGirl1;
    private RadioButton radioButtonBoy2;
    private RadioButton radioButtonGirl2;
    private String imageSrc = "";

    public AvatarFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View RootView = inflater.inflate(R.layout.fragment_avatar, container, false);

        avatarButton = RootView.findViewById(R.id.button_avatarSelection);
        radioButtonBoy1 = RootView.findViewById(R.id.radioBoy1);
        radioButtonGirl1 = RootView.findViewById(R.id.radioGirl1);
        radioButtonBoy2 = RootView.findViewById(R.id.radioBoy2);
        radioButtonGirl2 = RootView.findViewById(R.id.radioGirl2);

        if(getActivity().getClass().equals(FormationActivity.class)){
            ((FormationActivity)getActivity()).setHideButton();
        }

        avatarButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(getActivity().getClass().equals(FormationActivity.class)){
                    getImageSrc();
                    if (imageSrc.equals("")){
                        ((FormationActivity)getActivity()).getImageToast();

                    }else{
                        ((FormationActivity)getActivity()).setAvatarImage(imageSrc);
                        ((FormationActivity)getActivity()).setVisibleButton();
                        ((FormationActivity)getActivity()).skipFormationDecision();
                        ((FormationActivity)getActivity()).getFormationFragment();
                    }

                }else{
                    getImageSrc();
                    if (imageSrc.equals("")){
                        ((MainMenuActivity)getActivity()).restartActivity();
                    }else{
                        ((MainMenuActivity)getActivity()).setAvatarImage(imageSrc);
                        ((MainMenuActivity)getActivity()).restartActivity();
                    }
                }

            }
        });

        View.OnClickListener radio_listenerA = new View.OnClickListener(){
            public void onClick(View v) {
                clearRadioChecked();
                radioButtonBoy1.setChecked(true);
            }
        };
        View.OnClickListener radio_listenerB = new View.OnClickListener(){
            public void onClick(View v) {
                clearRadioChecked();
                radioButtonGirl1.setChecked(true);
            }
        };
        View.OnClickListener radio_listenerC = new View.OnClickListener(){
            public void onClick(View v) {
                clearRadioChecked();
                radioButtonBoy2.setChecked(true);
            }
        };
        View.OnClickListener radio_listenerD = new View.OnClickListener(){
            public void onClick(View v) {
                clearRadioChecked();
                radioButtonGirl2.setChecked(true);
            }
        };


        radioButtonBoy1.setOnClickListener(radio_listenerA);
        radioButtonGirl1.setOnClickListener(radio_listenerB);
        radioButtonBoy2.setOnClickListener(radio_listenerC);
        radioButtonGirl2.setOnClickListener(radio_listenerD);


        return RootView;
    }

    public void clearRadioChecked() {
        radioButtonBoy1.setChecked(false);
        radioButtonGirl1.setChecked(false);
        radioButtonBoy2.setChecked(false);
        radioButtonGirl2.setChecked(false);

    }
    public void getImageSrc(){
        if(radioButtonBoy1.isChecked()){
            imageSrc = "boy1";
        }
        if(radioButtonGirl1.isChecked()){
            imageSrc = "girl1";
        }
        if(radioButtonBoy2.isChecked()){
            imageSrc = "boy2";
        }
        if(radioButtonGirl2.isChecked()){
            imageSrc = "girl2";
        }
    }


}
