package com.example.educode.controller.fragment;

import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.example.educode.R;
import com.example.educode.controller.activity.MainMenuActivity;


/**
 * A simple {@link Fragment} subclass.
 */
public class CertificateFragment extends Fragment {

    private EditText editTextName;
    private EditText editTextDNI;
    private Button downloadButton;
    private TextView textViewCategory;
    private Button backButton;
    private String fullName;
    private String dni;
    private String category;


    public CertificateFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View RootView = inflater.inflate(R.layout.fragment_certificate, container, false);

        category = ((MainMenuActivity)getActivity()).getCategoryName();

        editTextName = RootView.findViewById(R.id.editText_completeName);
        editTextDNI = RootView.findViewById(R.id.editText_DNI);
        downloadButton = RootView.findViewById(R.id.button_certificate);
        textViewCategory = RootView.findViewById(R.id.textView_categoryDownload);
        backButton = RootView.findViewById(R.id.button_backCertificate);


        backButton.setBackgroundResource(R.drawable.back);

        if(category.equals("Programador Junior")){
            textViewCategory.setText("Aún no puedes descargarte ningún certificado. Debes de subir de categoría");
            downloadButton.setVisibility(View.GONE);

        }else{
            downloadButton.setBackgroundResource(R.drawable.download);
            textViewCategory.setText("Puede descargarte el certificado de la categoria " + category);
        }

        backButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).getOptionsMenuFragment();
            }
        });

        downloadButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                fullName = editTextName.getText().toString();
                dni = editTextDNI.getText().toString();
                if(fullName.equals("") | (dni == "")){
                    ((MainMenuActivity)getActivity()).toastNeedCertificateName();
                }else{
                    generatePDF();
                }

            }
        });



        return RootView;
    }

     private void generatePDF() {
         ((MainMenuActivity)getActivity()).generatePDF(fullName, dni);
    }

}
