package com.example.educode.controller.fragment;


import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.example.educode.controller.activity.MainMenuActivity;
import com.example.educode.R;


/**
 * A simple {@link Fragment} subclass.
 */
public class EndGameFragment extends Fragment {

    private TextView congratulationsTextView;
    private TextView correctAnswersTextView;
    private ImageView winView;
    private Button acceptButton;
    private int dailyFlag;

    public EndGameFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View RootView = inflater.inflate(R.layout.fragment_end_game, container, false);

        dailyFlag = ((MainMenuActivity)getActivity()).getdailyFlag();
        winView = RootView.findViewById(R.id.imageView_win);
        acceptButton = RootView.findViewById(R.id.button_accept);
        congratulationsTextView = RootView.findViewById(R.id.textView_congratulations);
        correctAnswersTextView = RootView.findViewById(R.id.textView_correctAnswers);

        if(dailyFlag == 1){
            if(((MainMenuActivity)getActivity()).getDailyWin() == 1){
                congratulationsTextView.setText("Felicidades " + ((MainMenuActivity)getActivity()).getPlayername());
                winView.setImageResource(R.drawable.win);
                correctAnswersTextView.setText("Has acertado la pregunta");
            }else{
                congratulationsTextView.setText("Que pena " + ((MainMenuActivity)getActivity()).getPlayername());
                winView.setImageResource(R.drawable.lose);
                correctAnswersTextView.setText("No has acertado la pregunta");
            }
        }else{
            if(((MainMenuActivity)getActivity()).checkWin()){
                congratulationsTextView.setText("Felicidades " + ((MainMenuActivity)getActivity()).getPlayername());


                if(((MainMenuActivity)getActivity()).checkAllCorrect()){
                    winView.setImageResource(R.drawable.win);
                    correctAnswersTextView.setText("Has acertado todas");
                }else{
                    winView.setImageResource(R.drawable.win2);
                    correctAnswersTextView.setText("Has acertado " + ((MainMenuActivity)getActivity()).getNumQuestionCorrect() + " de " + ((MainMenuActivity)getActivity()).getMaxQuestionCharged());
                }
            }else{
                if(((MainMenuActivity)getActivity()).checkAllWrong()){
                    congratulationsTextView.setText("Has perdido " + ((MainMenuActivity)getActivity()).getPlayername());
                    correctAnswersTextView.setText("No has acertado ninguna");
                    winView.setImageResource(R.drawable.lose2);
                }else {
                    congratulationsTextView.setText("Has perdido " + ((MainMenuActivity)getActivity()).getPlayername());
                    correctAnswersTextView.setText("Solo has acertado " + ((MainMenuActivity)getActivity()).getNumQuestionCorrect() + " de " + ((MainMenuActivity)getActivity()).getMaxQuestionCharged());
                    winView.setImageResource(R.drawable.lose);
                }

            }
        }


        acceptButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).restartActivity();
            }
        });

        return RootView;
    }


}
