package com.example.educode.controller.fragment;


import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.educode.controller.activity.MainMenuActivity;
import com.example.educode.R;
import com.example.educode.model.FillQuestion;


/**
 * A simple {@link Fragment} subclass.
 */
public class FillQuestionFragment extends Fragment {

    private FillQuestion question;
    private TextView textView_questionID;
    private ImageView questionImage;
    private EditText editText;
    private Button answerButton;
    private int dailyFlag;
    private int winDaily;

    public FillQuestionFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View RootView = inflater.inflate(R.layout.fragment_fill_question, container, false);

        dailyFlag = ((MainMenuActivity)getActivity()).getdailyFlag();
        if(dailyFlag == 1){
            question = (FillQuestion) ((MainMenuActivity)getActivity()).getDailyQuestion();
        }else{
            question = (FillQuestion) ((MainMenuActivity)getActivity()).getQuestion();
        }

        textView_questionID = (TextView) RootView.findViewById(R.id.textView_FillQuestionID);
        questionImage = (ImageView) RootView.findViewById(R.id.imageView_FillQuestion);
        answerButton = (Button) RootView.findViewById(R.id.button_Fillanswer);
        editText = (EditText) RootView.findViewById(R.id.editText_FillQuestion);

        textView_questionID.setText(question.getQuestionText());
        questionImage.setImageResource(getResources().getIdentifier(question.getImagen(), "drawable", "com.example.educode"));
        answerButton.setBackgroundResource(R.drawable.next);

        View.OnClickListener checkTheAnswer = new View.OnClickListener(){
            public void onClick(View v) {
                if(IsCheckedAnswer()){
                    if(dailyFlag == 1){
                        if(CheckAnswerIsTrue()){
                            ((MainMenuActivity)getActivity()).addPoints(200);
                            winDaily = 1;
                        }else{
                            ((MainMenuActivity)getActivity()).SoundWrong();
                            winDaily = 0;
                        }
                        ((MainMenuActivity)getActivity()).setDailyWin(winDaily);
                        ((MainMenuActivity)getActivity()).endDailyQuestion();
                    }else{
                        if(CheckAnswerIsTrue()){
                            ((MainMenuActivity)getActivity()).addPoints(50);
                        }else{
                            ((MainMenuActivity)getActivity()).SoundWrong();
                        }
                        ((MainMenuActivity)getActivity()).nextQuestion();
                    }
                }else{
                    Toast.makeText(getActivity(), "Debes escribir una respuesta", Toast.LENGTH_SHORT).show();
                }

            }
        };

        answerButton.setOnClickListener(checkTheAnswer);


        return RootView;

    }

    public boolean IsCheckedAnswer(){
        if(editText.getText().toString().equals("")){
            return false;
        }else{
            return true;
        }
    }

    public boolean CheckAnswerIsTrue(){
        if(editText.getText().toString().toLowerCase().equals(question.getCorrect().toLowerCase())){
            return true;
        }else{
            return false;
        }
    }

}
