package com.example.educode.controller.fragment;


import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.example.educode.controller.activity.MainMenuActivity;
import com.example.educode.R;


/**
 * A simple {@link Fragment} subclass.
 */
public class MenuFragment extends Fragment {

    private Button playButton;
    private Button optionButton;
    private Button exitButton;
    private ImageView avatarImageView;
    private ImageView dailyImageView;
    private TextView name;

    public MenuFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View RootView = inflater.inflate(R.layout.fragment_menu, container, false);

        playButton = RootView.findViewById(R.id.button_play);
        optionButton = RootView.findViewById(R.id.button_options);
        exitButton = RootView.findViewById(R.id.button_exit);
        avatarImageView = RootView.findViewById(R.id.imageView_avatar);
        dailyImageView = RootView.findViewById(R.id.imageView_daily);
        name = RootView.findViewById(R.id.textView_printName);

        name.setText(((MainMenuActivity)getActivity()).getPlayername());

        if(((MainMenuActivity)getActivity()).isDailyAvailable()){
            dailyImageView.setImageResource(getResources().getIdentifier("daily", "drawable", "com.example.educode"));
        }else{
            dailyImageView.setVisibility(View.GONE);
        }

        if(!((MainMenuActivity)getActivity()).getAvatarString().equals("")){
            avatarImageView.setImageResource(getResources().getIdentifier(((MainMenuActivity)getActivity()).getAvatarString(), "drawable", "com.example.educode"));
        }

        playButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).play();
            }
        });

        optionButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).getMenuOptionsFragmentTransaction();
            }
        });

        exitButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).exitApplication();
            }
        });

        dailyImageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).startDailyQuestion();
            }
        });

        return RootView;
    }

}
