package com.example.educode.controller.fragment;


import android.app.ProgressDialog;
import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.os.Handler;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.example.educode.controller.activity.MainMenuActivity;
import com.example.educode.R;


/**
 * A simple {@link Fragment} subclass.
 */
public class OptionsMenuFragment extends Fragment {


    private Button changeNameButton;
    private Button changeAvatarButton;
    private Button certificateButton;
    private Button rankingButton;
    private Button musicAvailableButton;
    private Button backButton;
    private TextView musicTextView;
    private ProgressDialog mDialog;


    public OptionsMenuFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View RootView = inflater.inflate(R.layout.fragment_options_menu, container, false);

        musicAvailableButton = RootView.findViewById(R.id.button_music);
        changeAvatarButton = RootView.findViewById(R.id.button_changeAvatar);
        certificateButton = RootView.findViewById(R.id.button_certificate);
        backButton = RootView.findViewById(R.id.button_back);
        changeNameButton = RootView.findViewById(R.id.button_changeName);
        rankingButton = RootView.findViewById(R.id.button_ranking);
        musicTextView = RootView.findViewById(R.id.textView_music);

        backButton.setBackgroundResource(R.drawable.back);
        changeAvatarButton.setBackgroundResource(R.drawable.portrait);
        certificateButton.setBackgroundResource(R.drawable.certificate);
        rankingButton.setBackgroundResource(R.drawable.cup);
        changeNameButton.setBackgroundResource(R.drawable.name);

        if(((MainMenuActivity)getActivity()).isMusicAvailable()){
            musicAvailableButton.setBackgroundResource(R.drawable.music_off);
            musicTextView.setText("Desactivar Música");

        }else{
            musicAvailableButton.setBackgroundResource(R.drawable.music_on);
            musicTextView.setText("Activar Música");
        }


        musicAvailableButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(((MainMenuActivity)getActivity()).isMusicAvailable()){
                    ((MainMenuActivity)getActivity()).setMusicAvailable(0);
                    ((MainMenuActivity)getActivity()).restartActivity();
                }else{
                    ((MainMenuActivity)getActivity()).setMusicAvailable(1);
                    ((MainMenuActivity)getActivity()).restartActivity();
                }
            }
        });



        changeAvatarButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).getAvatarFragment();
            }
        });

        certificateButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).getCertificateFragment();
            }
        });

        backButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).getMenuFragment();
            }
        });

        changeNameButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ((MainMenuActivity)getActivity()).getNameFragment();
            }
        });

        rankingButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Get ranking from FireBase to SQLite
                ((MainMenuActivity)getActivity()).getRanking();

                mDialog = new ProgressDialog(getActivity());
                mDialog.setMessage("Espere un momento...");
                mDialog.setCanceledOnTouchOutside(false);
                mDialog.show();

                Handler handler = new Handler();
                handler.postDelayed(new Runnable() {
                    public void run() {
                        ((MainMenuActivity)getActivity()).getRankingFragment();
                        mDialog.dismiss();
                    }
                }, 3000);



            }
        });


        return RootView;
    }

}
