package com.example.educode.controller.fragment;



import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.Toast;

import com.example.educode.controller.activity.MainMenuActivity;
import com.example.educode.R;
import com.example.educode.model.RadioQuestion;


/**
 * A simple {@link Fragment} subclass.
 */
public class RadioQuestionFragment extends Fragment {

    private TextView textView_questionID;
    private RadioQuestion question;
    private ImageView questionImage;
    private RadioButton radioButtonA;
    private RadioButton radioButtonB;
    private RadioButton radioButtonC;
    private RadioButton radioButtonD;
    private Button answerButton;
    private String Answer;
    private int dailyFlag;
    private int winDaily;




    public RadioQuestionFragment() {
        // Required empty public constructor
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View RootView = inflater.inflate(R.layout.fragment_radio_question, container, false);
        dailyFlag = ((MainMenuActivity)getActivity()).getdailyFlag();
        if(dailyFlag == 1){
            question = (RadioQuestion) ((MainMenuActivity)getActivity()).getDailyQuestion();
        }else{
            question = (RadioQuestion) ((MainMenuActivity)getActivity()).getQuestion();
        }

        textView_questionID = (TextView) RootView.findViewById(R.id.textView_questionID);
        questionImage = (ImageView) RootView.findViewById(R.id.imageView_question);
        radioButtonA = RootView.findViewById(R.id.radioButtonA);
        radioButtonB = RootView.findViewById(R.id.radioButtonB);
        radioButtonC = RootView.findViewById(R.id.radioButtonC);
        radioButtonD = RootView.findViewById(R.id.radioButtonD);
        answerButton = RootView.findViewById(R.id.button_answer);

        answerButton.setBackgroundResource(R.drawable.next);


        textView_questionID.setText(question.getQuestionText());
        questionImage.setImageResource(getResources().getIdentifier(question.getImagen(), "drawable", "com.example.educode"));
        radioButtonA.setText(question.getA());
        radioButtonB.setText(question.getB());
        radioButtonC.setText(question.getC());
        radioButtonD.setText(question.getD());


        View.OnClickListener radio_listenerA = new View.OnClickListener(){
            public void onClick(View v) {
                clearRadioChecked();
                radioButtonA.setChecked(true);
            }
        };
        View.OnClickListener radio_listenerB = new View.OnClickListener(){
            public void onClick(View v) {
                clearRadioChecked();
                radioButtonB.setChecked(true);
            }
        };
        View.OnClickListener radio_listenerC = new View.OnClickListener(){
            public void onClick(View v) {
                clearRadioChecked();
                radioButtonC.setChecked(true);
            }
        };
        View.OnClickListener radio_listenerD = new View.OnClickListener(){
            public void onClick(View v) {
                clearRadioChecked();
                radioButtonD.setChecked(true);
            }
        };

        View.OnClickListener checkTheAnswer = new View.OnClickListener(){
            public void onClick(View v) {
                if(IsCheckedAnswer()){
                    if(dailyFlag == 1){
                        if(CheckAnswerIsTrue()){
                            ((MainMenuActivity)getActivity()).addPoints(200);
                            winDaily = 1;
                        }else{
                            ((MainMenuActivity)getActivity()).SoundWrong();
                            winDaily = 0;
                        }
                        ((MainMenuActivity)getActivity()).setDailyWin(winDaily);
                        ((MainMenuActivity)getActivity()).endDailyQuestion();
                    }else{
                        if(CheckAnswerIsTrue()){
                            ((MainMenuActivity)getActivity()).addPoints(50);
                        }else{
                            ((MainMenuActivity)getActivity()).SoundWrong();
                        }
                        ((MainMenuActivity)getActivity()).nextQuestion();
                    }
                }else{
                    Toast.makeText(getActivity(), "Debes elegir una respuesta", Toast.LENGTH_SHORT).show();
                }

            }
        };
        radioButtonA.setOnClickListener(radio_listenerA);
        radioButtonB.setOnClickListener(radio_listenerB);
        radioButtonC.setOnClickListener(radio_listenerC);
        radioButtonD.setOnClickListener(radio_listenerD);
        answerButton.setOnClickListener(checkTheAnswer);


        return RootView;

    }

    public void clearRadioChecked() {
        radioButtonA.setChecked(false);
        radioButtonB.setChecked(false);
        radioButtonC.setChecked(false);
        radioButtonD.setChecked(false);
    }
    public boolean IsCheckedAnswer(){
        if (radioButtonA.isChecked()) {
            Answer = question.getA();
            return true;
        } else if (radioButtonB.isChecked()) {
            Answer = question.getB();
            return true;
        } else if (radioButtonC.isChecked()) {
            Answer = question.getC();
            return true;
        } else if (radioButtonD.isChecked()) {
            Answer = question.getD();
            return true;
        }
        return false;
    }

    public boolean CheckAnswerIsTrue() {
        if(Answer.equals(question.getCorrect())){
            return true;
        }else{
            return false;
        }
    }



}
