package com.example.educode.data;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

import androidx.annotation.NonNull;

import com.example.educode.model.FillQuestion;
import com.example.educode.model.Question;
import com.example.educode.model.RadioQuestion;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.firestore.DocumentReference;
import com.google.firebase.firestore.DocumentSnapshot;
import com.google.firebase.firestore.FirebaseFirestore;
import com.google.firebase.firestore.QueryDocumentSnapshot;
import com.google.firebase.firestore.QuerySnapshot;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class DBFacade {

    private SQLiteDatabase db;
    private Context context;
    private Question[] preChargedLevelQuestions = new Question[50];
    private Object MainMenuActivity;
    private FirebaseAuth mAuth;
    private FirebaseFirestore dbFireStore = FirebaseFirestore.getInstance();

    public DBFacade(Context context){
        this.context = context;
    }

    public void updatePlayerValue(String column, int value){
        db = getDbConection();
        ContentValues values = new ContentValues();
        values.put(column, value);
        db.update("jugador", values,null, null);
        db.close();
    }

    public void updatePlayerValue(String column, String value){
        db = getDbConection();
        ContentValues values = new ContentValues();
        values.put(column, value);
        db.update("jugador", values,null, null);
        db.close();
    }

    public void updatePlayerValueToFirebase(String column, String value){
        dbFireStore.collection("users").document(getEmail()).update(column, value);
    }

    public void updatePlayerValueToFirebase(String column, int value){
        dbFireStore.collection("users").document(getEmail()).update(column, value);
    }


    public String getPlayerStringValue(int column){
        db = getDbConection();
        Cursor consultaString = db.rawQuery("select * from jugador where id = 1", null);
        if (consultaString.moveToFirst()){
            db.close();
            return consultaString.getString(column);

        }else{
            db.close();
            return "";
        }
    }

    public int getPlayerIntValue(int column){
        db = getDbConection();
        Cursor consultaString = db.rawQuery("select * from jugador where id = 1", null);
        if (consultaString.moveToFirst()){
            db.close();
            return consultaString.getInt(column);

        }else{
            db.close();
            return 0;
        }
    }


    public void createPlayer(String name, String email){
        db = getDbConection();
        Date currentTime = Calendar.getInstance().getTime();
        SimpleDateFormat simpleformat1 = new SimpleDateFormat("dd");
        SimpleDateFormat simpleformat2 = new SimpleDateFormat("MM");
        SimpleDateFormat simpleformat3 = new SimpleDateFormat("yyyy");

        ContentValues values = new ContentValues();
        values.put("id", 1);
        values.put("nombre", name);
        values.put("puntos", 0);
        values.put("categoria", "Programador Junior");
        values.put("formacion", 0);
        values.put("avatar", "boy1");
        values.put("music", 0);
        values.put("daily", 1);
        values.put("dailyday", simpleformat1.format(currentTime.getTime()));
        values.put("dailymonth", simpleformat2.format(currentTime.getTime()));
        values.put("dailyyear", simpleformat3.format(currentTime.getTime()));
        values.put("email", email);


        db.insert("jugador", null, values);
        db.update("jugador", values,null, null);
        db.close();
    }

    public void createFireStorePlayer(String name, String email){
        Date currentTime = Calendar.getInstance().getTime();
        SimpleDateFormat simpleformat1 = new SimpleDateFormat("dd");
        SimpleDateFormat simpleformat2 = new SimpleDateFormat("MM");
        SimpleDateFormat simpleformat3 = new SimpleDateFormat("yyyy");

        Map<String, Object> user = new HashMap<>();
        user.put("nombre", name);
        user.put("puntos", 0);
        user.put("categoria", "Programador Junior");
        user.put("formacion", 0);
        user.put("avatar", "boy1");
        user.put("music", 0);
        user.put("daily", 1);
        user.put("dailyday", simpleformat1.format(currentTime.getTime()));
        user.put("dailymonth", simpleformat2.format(currentTime.getTime()));
        user.put("dailyyear", simpleformat3.format(currentTime.getTime()));


        dbFireStore.collection("users").document(email).set(user).addOnSuccessListener(new OnSuccessListener<Void>() {
            @Override
            public void onSuccess(Void aVoid) {

            }
        }).addOnFailureListener(new OnFailureListener() {
            @Override
            public void onFailure(@NonNull Exception e) {

            }
        });
    }

    public void createUserFromFirebaseStore(String email){
        DocumentReference docRef = dbFireStore.collection("users").document(email);
        docRef.get().addOnCompleteListener(new OnCompleteListener<DocumentSnapshot>() {
            @Override
            public void onComplete(@NonNull Task<DocumentSnapshot> task) {
                if (task.isSuccessful()) {
                    DocumentSnapshot document = task.getResult();
                    if (document.exists()) {
                        createPlayer(document.get("nombre").toString(), email);
                        updatePlayerValue("categoria", document.get("categoria").toString());
                        updatePlayerValue("puntos", document.get("puntos").toString());
                        updatePlayerValue("formacion", document.get("formacion").toString());
                        updatePlayerValue("avatar", document.get("avatar").toString());
                        updatePlayerValue("music", document.get("music").toString());
                        updatePlayerValue("daily", document.get("daily").toString());
                        updatePlayerValue("dailyday", document.get("dailyday").toString());
                        updatePlayerValue("dailymonth", document.get("dailymonth").toString());
                        updatePlayerValue("dailyyear", document.get("dailyyear").toString());

                    } else {

                    }
                } else {

                }
            }
        });
    }

    public int[] getIntStats() {
        int[] intStats = new int[10];
        db = getDbConection();

        Cursor consulta = db.rawQuery("select * from jugador where id = 1", null);

        if (consulta.moveToFirst()) {
            intStats[0] = consulta.getInt(2);
            intStats[1] = consulta.getInt(6);
            intStats[2] = consulta.getInt(7);
            intStats[3] = consulta.getInt(8);
            intStats[4] = consulta.getInt(9);
            intStats[5] = consulta.getInt(10);
        }
        db.close();
        consulta.close();
        return intStats;
    }
    public String[] getStringStats() {
        String[] stringStats = new String[10];
        db = getDbConection();

        Cursor consulta = db.rawQuery("select * from jugador where id = 1", null);

        if (consulta.moveToFirst()) {
            stringStats[0] = consulta.getString(1);
            stringStats[1] = consulta.getString(2);
            stringStats[2] = consulta.getString(3);
            stringStats[3] = consulta.getString(4);
            stringStats[4] = consulta.getString(5);
            stringStats[5] = consulta.getString(11);
        }
        db.close();
        consulta.close();
        return stringStats;
    }


    public SQLiteDatabase getDbConection() {
        AdminSQLiteOpenHelper admin = new AdminSQLiteOpenHelper(this.context, "db", null, 1);
        SQLiteDatabase db = admin.getWritableDatabase();
        return db;
    }

    public void insertAllQuestionsToDB(){
        //Programador Junior
        insertRadioQuestion(3, "radio3", "Int", "Double", "Float", "Todas", "Todas", "Programador Junior", "¿De qué tipo puede ser la variable X?");
        insertRadioQuestion(4, "radio4", "Condicional", "Bucle", "Lineal", "Estática", "Bucle", "Programador Junior", "¿Qué tipo de estructura tenemos?");
        insertRadioQuestion(5, "radio5", "SI", "No", "SiHola", "NoHola", "NoHola", "Programador Junior", "¿Si el nombre es Hugo, ¿qué salida obtendremos?");
        insertRadioQuestion(6, "radio6", "Integer", "Array", "String", "Bucle", "Array", "Programador Junior", "¿Qué estructura de datos es la variable preguntas?");
        insertRadioQuestion(7, "radio7", "Boolean", "String", "Int", "Nada", "Boolean", "Programador Junior", "¿Qué tipo de dato devuelve la función 'isAvailable'?");
        insertRadioQuestion(11, "radio11", "4", "7", "8", "6", "7", "Programador Junior", "¿Qué valor tiene la variable X al final?");
        insertRadioQuestion(12, "radio12", "44", "45", "46", "48", "44", "Programador Junior", "¿Qué valor tiene la variable X al final?");
        insertRadioQuestion(13, "radio13", "8", "9", "13", "10", "13", "Programador Junior", "¿Qué valor tiene la variable Y al final?");
        insertRadioQuestion(14, "radio14", "Condicional", "Bucle", "Lineal", "Estática", "Condicional", "Programador Junior", "¿Qué tipo de estructura tenemos?");
        insertRadioQuestion(15, "radio15", "6", "5", "2", "1", "1", "Programador Junior", "¿En qué linea se declara la variable 'palabras'?");
        insertRadioQuestion(16, "radio15", "1", "4", "2", "5", "2", "Programador Junior", "¿En qué linea se inicializa la variable 'palabras'?");
        insertRadioQuestion(17, "radio17", "2", "3", "235", "23", "235", "Programador Junior", "¿Qué lineas pueden dar error el código?");
        insertRadioQuestion(18, "radio17", "2", "3", "No da error", "5", "2", "Programador Junior", "¿Qué linea dará error primero?");
        insertRadioQuestion(19, "radio19", "134", "13", "1234", "12", "134", "Programador Junior", "Suponiendo qué X vale 6 ¿cuál será la salida?");
        insertRadioQuestion(20, "radio20", "26", "356", "346", "34", "356", "Programador Junior", "Suponiendo qué X vale 9 ¿cuál será la salida?");
        insertRadioQuestion(21, "radio21", "Es Jane", "Da error", "Es Peter", "Es Mike", "Da error", "Programador Junior", "¿Cuál será la salida?");
        insertRadioQuestion(22, "radio22", "Boolean", "Int", "String", "Char", "Int", "Programador Junior", "Si sabemos qué check devuelve 1, ¿qué tipo de variable será?");
        insertRadioQuestion(23, "radio22", "Boolean", "Int", "String", "Char", "String", "Programador Junior", "Si sabemos qué check devuelve 'OK', ¿qué tipo de variable será?");
        insertRadioQuestion(24, "radio24", "O", "KO", "K", "OK", "KO", "Programador Junior", "¿Qué devuelve el programa?");
        insertRadioQuestion(25, "radio25", "KK", "KO", "K", "OK", "K", "Programador Junior", "¿Qué devuelve el programa?");
        insertRadioQuestion(26, "radio26", "Matriz", "Vector", "Extensible", "Condicional", "Matriz", "Programador Junior", "¿Qué estructura de datos tenemos?");
        insertRadioQuestion(27, "radio27", "3", "5", "8", "7", "8", "Programador Junior", "¿Qué número obtendremos al acceder a la posición de la matriz?");
        insertRadioQuestion(28, "radio28", "0", "2", "3", "1", "3", "Programador Junior", "¿Qué resultado obtendremos?");
        insertRadioQuestion(29, "radio29", "[1][2]", "[2][3]", "[2][1]", "[3][2]", "[2][1]", "Programador Junior", "¿Si queremos acceder al 8...?");

        //Programador Senior
        insertRadioQuestion(1, "radio1", "68", "62", "65", "71", "65", "Programador Senior", "¿Cuál es el resultado de Y?");
        insertRadioQuestion(2, "radio2", "2", "3", "1", "0", "1", "Programador Senior", "¿Cuántas veces se ejecuta el bucle?");
        insertRadioQuestion(8, "radio8", "Nada", "False", "1", "True", "True", "Programador Senior", "¿Qué devuelve la llamada a la función 'isAvailable(x)'?");
        insertRadioQuestion(9, "radio9", "5", "1", "Infinito", "2", "Infinito", "Programador Senior", "¿Cuántas veces se ejecutará el bucle?");
        insertRadioQuestion(10, "radio10", "1", "2", "3", "123", "1", "Programador Senior", "¿Qué imprimirá por pantalla la aplicación?");

        //Analista de Software
        insertRadioQuestion(30, "radio30", "sumar(2,3)", "sumar{2,3}", "sumar[2,3]", "sumar,2,3", "sumar(2,3)", "Programador Junior", "¿Cuál sería la manera correcta de llamar a la función sumar?");
        insertRadioQuestion(31, "radio31", "Jack", "James", "John", "Da error", "Da error", "Analista de Software", "¿Que devuelve el programa?");
        insertRadioQuestion(32, "radio32", "Charles", "Chon", "XCO", "x", "XCO", "Analista de Software", "¿Que devuelve el programa?");
        insertRadioQuestion(33, "radio33", "01", "014162536", "0141625", "da Error", "Da Error", "Analista de Software", "¿Que devuelve la función function(6)?");

        //Ingeniero de Software
        insertRadioQuestion(34, "radio34", "b y d", "14", "15", "13", "b y d", "Ingeniero de Software", "Si la función devuelve 68");
        insertRadioQuestion(35, "radio35", "13", "16", "8", "todas", "todas", "Ingeniero de Software", "Si la función devuelve 0");


        //Programador Junior
        insertFillQuestion(1, "fill1", "if", "Programador Junior", "¿Qué tipo de estructura tenemos?");
        insertFillQuestion(2, "fill2", "while", "Programador Junior", "Si x acaba valiendo 4, ¿Qué estructura tenemos?");
        insertFillQuestion(3, "fill3", "1", "Programador Junior", "Si y acaba valiendo 21, ¿cuánto valdrá inicialmente?");
        insertFillQuestion(4, "fill4", "2", "Programador Junior", "Si y acaba valiendo 6, ¿cuánto valdrá inicialmente?");
        insertFillQuestion(5, "fill5", "int", "Programador Junior", "Por el contexto, ¿qué tipo de dato será?");
        insertFillQuestion(6, "fill6", "String", "Programador Junior", "Por el contexto, ¿qué tipo de dato será?");
        insertFillQuestion(7, "fill7", "O", "Programador Junior", "Si la salida es 'KK'...");
        insertFillQuestion(8, "fill8", "1", "Programador Junior", "Si la salida es OK, qué posición ocupa en el array la 'O'");
        insertFillQuestion(9, "fill9", "201", "Programador Junior", "Si la salida es 'Es Jane', escribe las posiciones del array en orden");
        insertFillQuestion(10, "fill9", "021", "Programador Junior", "Si la salida es 'Es Peter', escribe las posiciones del array en orden");
        insertFillQuestion(11, "fill11", "true", "Programador Junior", "Si la función devuelve un booleano...");
        insertFillQuestion(12, "fill12", "}", "Programador Junior", "¿Qué falta en este código?");
        insertFillQuestion(13, "fill13", ";", "Programador Junior", "¿Qué falta en este código?");
        insertFillQuestion(14, "fill14", "i", "Programador Junior", "Según el contexto, ¿qué falta en este código?");
        insertFillQuestion(15, "fill15", "return", "Programador Junior", "¿Qué falta en este código?");
        insertFillQuestion(16, "fill16", "break", "Programador Junior", "Si queremos salir del bucle, ¿que debemos escribir?");

        //Analista de Software
        insertFillQuestion(17, "fill17", "83", "Analista de Software", "Que devuelve la llamada a la función CalcNum(5,3)");
        insertFillQuestion(18, "fill18", "0", "Analista de Software", "Que devuelve la llamada a la función CalcNum(4,3)");
        insertFillQuestion(19, "fill19", "014916", "Analista de Software", "Que devuelve la llamada a la función function(5)");

        //Ingeniero de Software
        insertFillQuestion(20, "fill20", "014916253649", "Ingeniero de Software", "Que devuelve la llamada a la función function(7)");
        insertFillQuestion(21, "fill21", "implements", "Ingeniero de Software", "¿Si desde una clase queremos implementar esta interfaz...?");
        insertFillQuestion(22, "fill22", "extends", "Ingeniero de Software", "Rellena el hueco");

    }

    public void insertRadioQuestion(int id, String imagen, String a, String b, String c, String d, String correct, String level, String question){

        db = getDbConection();
        ContentValues values = new ContentValues();
        values.put("id", id);
        values.put("imagen", imagen);
        values.put("a", a);
        values.put("b", b);
        values.put("c", c);
        values.put("d", d);
        values.put("correct", correct);
        values.put("level", level);
        values.put("question", question);

        db.insert("radioQuestion", null, values);
        db.close();
    }

    public void insertFillQuestion(int id, String imagen, String correct, String level, String question){

        db = getDbConection();
        ContentValues values = new ContentValues();
        values.put("id", id);
        values.put("imagen", imagen);
        values.put("correct", correct);
        values.put("level", level);
        values.put("question", question);

        db.insert("fillQuestion", null, values);
        db.close();
    }

    public Question[] getAllRadioQuestionsPerLevel(String category){
        int index = 0;
        int idQuestion = 1;
        while(true) {
            db = getDbConection();
            Cursor consulta = db.rawQuery("select * from radioQuestion where id =?", new String [] {String.valueOf(idQuestion)});

            if (consulta.moveToFirst()) {
                if(consulta.getString(7).equals(category)){
                    preChargedLevelQuestions[index] = new RadioQuestion(consulta.getInt(0), consulta.getString(1), consulta.getString(2), consulta.getString(3), consulta.getString(4), consulta.getString(5), consulta.getString(6), consulta.getString(7), consulta.getString(8));
                    index++;
                }
            }else{
                break;
            }
            consulta.close();
            db.close();
            idQuestion++;
        }
        return preChargedLevelQuestions;
    }
    public Question[] getAllFillQuestionsPerLevel(String category){
        int index = 0;
        int idQuestion = 1;
        while(true) {
            db = getDbConection();
            Cursor consulta = db.rawQuery("select * from fillQuestion where id =?", new String [] {String.valueOf(idQuestion)});

            if (consulta.moveToFirst()) {
                if(consulta.getString(3).equals(category)){
                    preChargedLevelQuestions[index] = new FillQuestion(consulta.getInt(0), consulta.getString(1), consulta.getString(2), consulta.getString(3), consulta.getString(4));
                    index++;
                }
            }else{
                break;
            }
            consulta.close();
            db.close();
            idQuestion++;
        }
        return preChargedLevelQuestions;
    }

    public String getEmail(){
        return getPlayerStringValue(11);
    }

    public void createRankingFromFireStore(){
        db = getDbConection();
        db.execSQL("delete from "+ "ranking");

        dbFireStore.collection("users")
                .get()
                .addOnCompleteListener(new OnCompleteListener<QuerySnapshot>() {
                    @Override
                    public void onComplete(@NonNull Task<QuerySnapshot> task) {
                        HashMap<Integer, String> playersName = new HashMap<Integer, String>();
                        HashMap<Integer, Integer> playersPoints = new HashMap<Integer, Integer>();
                        int i = 0;
                        if (task.isSuccessful()) {
                            for (QueryDocumentSnapshot document : task.getResult()) {
                                String name = document.get("nombre").toString();
                                String puntos = document.get("puntos").toString();
                                playersName.put(i, name);
                                playersPoints.put(i, Integer.valueOf(puntos));
                                Log.e("FOR", "Getting Document Successfully: ", task.getException());
                                i++;
                            }
                        } else {
                            //Log.e("RANKING", "Error getting documents: ", task.getException());
                        }

                        HashMap<Integer, Integer> playersPoints2 = sortByValue(playersPoints);

                        int x = 1;
                        for (HashMap.Entry<Integer, Integer> entry : playersPoints2.entrySet()) {
                            Log.e("DATO", "clave=" + entry.getKey() + ", valor=" + entry.getValue());
                            insertPlayerToRanking(x, playersName.get(entry.getKey()),  entry.getValue());
                            x++;
                        }

                        //String[] prueba;
                        //prueba = getPlayerRankingByPosition(1);
                        //Log.e("RANKING1", getFirstRanking());
                        //Log.e("SORTFUNCTION", playersPoints2.values().toString());
                        //Log.e("getPlayerByPosition", prueba[0]);
                        //Log.e("getPlayerByPosition", prueba[1]);
                        //Log.e("getPlayerByPosition", prueba[2]);
                    }

                });
    }


    public void insertPlayerToRanking(int id, String name, int puntos){

        db = getDbConection();
        ContentValues values = new ContentValues();
        values.put("id", id);
        values.put("nombre", name);
        values.put("puntos", puntos);


        db.insert("ranking", null, values);
        db.close();
    }

    public String[] getPlayerRankingByPosition(int position){
        db = getDbConection();
        Cursor consulta = db.rawQuery("select * from ranking where id =?", new String[] {String.valueOf(position)});
        String[] player= new String[3];

        if (consulta.moveToFirst()) {
            player[0] = consulta.getString(0);
            player[1] = consulta.getString(1);
            player[2] = consulta.getString(2);
        }
        db.close();
        consulta.close();
        return player;
    }


    public static HashMap<Integer, Integer> sortByValue(HashMap<Integer, Integer> hm)
    {
        // Create a list from elements of HashMap
        List<Map.Entry<Integer, Integer> > list =
                new LinkedList<Map.Entry<Integer, Integer> >(hm.entrySet());

        // Sort the list
        Collections.sort(list, new Comparator<Map.Entry<Integer, Integer> >() {
            public int compare(Map.Entry<Integer, Integer> o2,
                               Map.Entry<Integer, Integer> o1)
            {
                return (o1.getValue()).compareTo(o2.getValue());
            }
        });

        // put data from sorted list to hashmap
        HashMap<Integer, Integer> temp = new LinkedHashMap<Integer, Integer>();
        for (Map.Entry<Integer, Integer> aa : list) {
            temp.put(aa.getKey(), aa.getValue());
        }
        return temp;
    }




}
