package com.example.educode.model;


import android.content.Context;

import com.example.educode.data.DBFacade;

public class Category {
    private String name;


    public Category(String name){
        this.name = name;
    }


    public String getName(){
        return this.name;
    }

    public void setName(String name){
        this.name = name;
    }

    /**
     * Method to check if the category has been changed when the points has been added
     * @param points current points
     * @param context Activity
     * @return True or false if the category has been changed
     */
    public boolean checkCategory(int points, Context context) {
        DBFacade dbFacade = new DBFacade(context);
        String categoria;
        if(points < 1500){
            return false;
        }
        if (points >= 2000 && name.equals("Programador Junior")) {
            categoria = "Programador Senior";
            dbFacade.updatePlayerValue("categoria", categoria);
            setName(categoria);
            return true;
        }
        if (points >= 5000 && name.equals("Programador Senior")) {
            categoria = "Analista de Software";
            dbFacade.updatePlayerValue("categoria", categoria);
            setName(categoria);
            return true;
        }
        if (points >= 10000 && name.equals("Analista de Software")) {
            categoria = "Ingeniero de Software";
            dbFacade.updatePlayerValue("categoria", categoria);
            setName(categoria);
            return true;
        }
        if (points >= 100000 && name.equals("Ingeniero de Software")) {
            categoria = "Ingeniero de la NASA";
            dbFacade.updatePlayerValue("categoria", categoria);
            setName(categoria);
            return true;
        }
        return false;
    }

}
