package com.example.educode.model;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class DateProject {

    private int day;
    private int month;
    private int year;
    private String pattern  = "dd/MMMM/yyyy";

    public DateProject(){
        Date currentTime = Calendar.getInstance().getTime();
        SimpleDateFormat simpleformat1 = new SimpleDateFormat("dd");
        SimpleDateFormat simpleformat2 = new SimpleDateFormat("MM");
        SimpleDateFormat simpleformat3 = new SimpleDateFormat("yyyy");
        this.day = Integer.parseInt(simpleformat1.format(currentTime.getTime()));
        this.month = Integer.parseInt(simpleformat2.format(currentTime.getTime()));
        this.year = Integer.parseInt(simpleformat3.format(currentTime.getTime()));
    }

    public DateProject(int day, int month, int year){
        this.day = day;
        this.month = month;
        this.year = year;
    }


    public int getDay() {
        return day;
    }

    public void setDay(int day) {
        this.day = day;
    }

    public int getMonth() {
        return month;
    }

    public void setMonth(int month) {
        this.month = month;
    }

    public int getYear() {
        return year;
    }

    public void setYear(int year) {
        this.year = year;
    }


    /**
     * Method to check if the daily should be available or not
     * @return true if the daily is available and false if the daily is disabled
     */
    public boolean checkDailyDate(){
        Date currentTime = Calendar.getInstance().getTime();
        SimpleDateFormat simpleformat1 = new SimpleDateFormat("dd");
        SimpleDateFormat simpleformat2 = new SimpleDateFormat("MM");
        SimpleDateFormat simpleformat3 = new SimpleDateFormat("yyyy");
        int day = Integer.parseInt(simpleformat1.format(currentTime.getTime()));
        int month = Integer.parseInt(simpleformat2.format(currentTime.getTime()));
        int year = Integer.parseInt(simpleformat3.format(currentTime.getTime()));

        if(day > getDay()){
            return true;
        }else if(month > getMonth()){
            return true;
        }else if(year > getYear()){
            return true;
        }
        return false;
    }

    public String getPatternDate(){
        Date currentTime = Calendar.getInstance().getTime();
        SimpleDateFormat simpleformat = new SimpleDateFormat(pattern);
        return simpleformat.format(currentTime.getTime());
    }
}
