package com.example.educode.model;

public class Player {

    private int id;
    private String email;
    private String name;
    private int points;
    private Category category;
    private String formation;
    private String avatar;
    private int music;
    private int daily;
    private DateProject date;

    public Player(int id, String name, int points, String category, String formation, String avatar, int music, int daily, int dailyDay, int dailyMonth, int dailyYear, String email){
        this.id = id;
        this.name = name;
        this.points = points;
        this.category = new Category(category);
        this.formation = formation;
        this.avatar = avatar;
        this.music = music;
        this.daily = daily;
        date = new DateProject(dailyDay, dailyMonth, dailyYear);
        this.email = email;
    }


    public String getCategoryName(){
        return category.getName();
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }


    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getPoints() {
        return points;
    }

    public String getPointsToString(){
        return Integer.toString(points);
    }

    public void setPoints(int points) {
        this.points = points;
    }

    public Category getCategory() {
        return category;
    }

    public String getFormation() {
        return formation;
    }

    public void setFormation(String formation) {
        this.formation = formation;
    }

    public String getAvatar() {
        return avatar;
    }

    public void setAvatar(String avatar) {
        this.avatar = avatar;
    }


    public int getMusic() {
        return music;
    }

    public void setMusic(int music) {
        this.music = music;
    }


    public int getDaily() {
        return daily;
    }

    public void setDaily(int daily) {
        this.daily = daily;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }


    public boolean isDailyAvailable(){
        if(daily == 1){
            return true;
        }else{
            return false;
        }
    }
    public boolean checkDailyQuestionAvailable(){
        if(date.checkDailyDate()){
            setDaily(1);
            return true;
        }else{
            return false;
        }
    }


}
